unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VclTee.TeeGDIPlus,
  VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Chart1: TChart;
    Series1: TFastLineSeries;
    Series2: TFastLineSeries;
    GroupBox1: TGroupBox;
    RadioButton2: TRadioButton;
    Button1: TButton;
    RadioButton1: TRadioButton;
    GroupBox2: TGroupBox;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{
 4̃Q^bN@
 K̏
 dy/dx=f(x,y)
}
function f(x, y: double):double;
begin
  result := 1;                            // _~[
  if Form1.RadioButton2.Checked then result := sin(x) + cos(y);
  if Form1.RadioButton1.Checked then result := 1 - y * y;          // x ͖
end;

procedure sumple1;
var
  i : integer;
  h, x, y, k1, k2, k3, k4: double;
begin
  h := 1;                                 //  _~[
  if Form1.RadioButton2.Checked then begin
    h := pi / 50;                         // 0`Ζ
    Form1.Chart1.Title.Text.Text := 'sin(x) + cos(y)';
  end;
  if Form1.RadioButton1.Checked then begin
    h := 1 / 50;                          // 0`1
    Form1.Chart1.Title.Text.Text := '1-y^2';
  end;
  x := 0;
  y := 0;
  i := 0;
  with Form1.memo1 do begin
    clear;
    Form1.Series1.Clear;
    Form1.Series2.Clear;
    Lines.Add('i             x              y');
    Lines.Add(inttostr(i) + '  ' + floatTostr(x) + '  ' + floatTostr(y));
    Form1.Series1.AddXY(x, y);
    for i := 1 to 50 do begin
      k1 := h * f(x, y);
      k2 := h * f(x + h / 2, y + k1 / 2);
      k3 := h * f(x + h / 2, y + k2 / 2);
      k4 := h * f(x + h,     y + k3);
      y  := y + (k1 + 2 * k2 + 2 * k3 + k4) / 6;      // dݕt
      x  := i * h;
      Lines.Add(inttostr(i) + '  ' + floatTostr(x) + '  ' + floatTostr(y));
      Form1.Series1.AddXY(x, y);
    end;
  end;
end;

// Ks
procedure TForm1.Button1Click(Sender: TObject);
begin
  sumple1;
end;

{
@K
@d^2/dx^2=x*dy/dx+y
  dy/dx=y' -------(a)
  dy'/dx=xy'+y ---(b)
}
function df(i:integer; x: double; s: array of double): double;
begin
{
  i=0   dy/dx=y'
  i=1   dy'/dx=xy'+y
}
  result := 0;
  case i of
    0 : result := s[1];
    1 : result := x * s[1] + s[0];
  end;
end;

procedure sumple2;
var
  j, k: integer;
  h, x: double;
  k1, k2, k3, k4, y, ywork: array[0..1] of double;
begin
  k := 20;
  h := 1 / k;
  x := 0;
  y[0] := 1;
  y[1] := 1;
  j := 0;
  with Form1 do begin
    Memo1.clear;
    Chart1.Title.Text.Text := 'dy/dx= y' + #39 + #13#10 + '    dy' + #39 + '/dx=y' + #39 + '+y';
    Series1.Clear;
    Series2.Clear;
    Memo1.Lines.Add('j             x              y[0],             y[1]');
    Memo1.Lines.Add(inttostr(j) + '  ' + floatTostr(x) + '  ' + floatTostr(y[0]) + '  ' + floatTostr(y[1]));
    Series1.addxy(x, y[0]);
    Series2.addxy(x, y[1]);
    for j := 1 to k do begin
      k1[0]    := h * df(0, x, y);
      k1[1]    := h * df(1, x, y);
      ywork[0] := y[0] + k1[0] / 2;
      ywork[1] := y[1] + k1[1] / 2;
      k2[0]    := h * df(0, x + h / 2, ywork);   // k2[0] := h * ywork[1]
      k2[1]    := h * df(1, x + h / 2, ywork);
      ywork[0] := y[0] + k2[0] / 2;
      ywork[1] := y[1] + k2[1] / 2;
      k3[0]    := h * df(0, x + h / 2, ywork);   // k3[0] := h * ywork[1]
      k3[1]    := h * df(1, x + h / 2, ywork);
      ywork[0] := y[0] + k3[0];
      ywork[1] := y[1] + k3[1];
      k4[0]    := h * df(0, x + h, ywork);       // k4[0] := h * ywork[1]
      k4[1]    := h * df(1, x + h, ywork);
      y[0]     := y[0] + (k1[0] + 2 * k2[0] + 2 * k3[0] + k4[0]) / 6;
      y[1]     := y[1] + (k1[1] + 2 * k2[1] + 2 * k3[1] + k4[1]) / 6;
      x        := h * j;
      Memo1.Lines.Add(inttostr(j) + '  ' + floatTostr(x) + '  ' + floatTostr(y[0]) + '  ' + floatTostr(y[1]));
      Series1.addxy(x, y[0]);
      Series2.addxy(x, y[1]);
    end;
  end;
end;

// Ks
procedure TForm1.Button2Click(Sender: TObject);
begin
  sumple2;
end;

end.
