// ꎩRxn̐U
// l̃QNb^@

unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  VCLTee.Series, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit7: TLabeledEdit;
    LabeledEdit8: TLabeledEdit;
    LabeledEdit9: TLabeledEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Chart1: TChart;
    Series1: TFastLineSeries;
    Chart2: TChart;
    Series2: TFastLineSeries;
    Chart3: TChart;
    Series3: TFastLineSeries;
    LabeledEdit10: TLabeledEdit;
    LabeledEdit11: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    function hzcalc: boolean;
    function inputdata: boolean;
    function Func(T: double; X: array of double): double;
    procedure Runge_Kutta(T, Dt: double;var X, Y: array of double);
    procedure calc;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  dblAK, dblAC      : double;
  dblb              : double;
  Omega, OmegQ      : double;

  dblM, dblC, dblK  : double;
  dblF, dblFe       : double;
  dblQ              : double;
  dblX0, dblV0      : double;
  dblT, dblTstt, dblTend, dblDt : double;
  dblX, dblY        : array[0..1] of double;
  Number, Numbstt   : integer;

// ŗLg@W̏
function TForm1.hzcalc: boolean;
var
  Check : integer;
begin
  result := false;
  val(LabeledEdit1.Text, dblM, Check);  // Kg
  if Check <> 0 then begin
    application.MessageBox('ʂ̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit2.Text, dblC, Check);  // NEs/m
  if Check <> 0 then begin
    application.MessageBox('W̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit3.Text, dblK, Check);  // N/m
  if Check <> 0 then begin
    application.MessageBox('΂˒萔̒lɊԈႢ܂B','',0);
    exit;
  end;
  if dblK <= 0 then begin
    application.MessageBox('΂˒萔̒l[́A[ȉłB','',0);
    exit;
  end;
  if dblM <= 0 then begin
    application.MessageBox('ʂ̒l[́B[ȉł͂܂B','',0);
    exit;
  end;
  // ŗLg                         Hz
  dblF := sqrt(dblK / dblM) / 2 / pi;
  // W 
  dblFe := dblC / 2 / sqrt(dblM * dblK);
  Edit1.Text := floattostr(dblF);
  Edit2.Text := floattostr(dblFe);
  result := True;
end;

// ̓f[^[
function TForm1.inputdata: boolean;
var
  check : integer;
begin
  result := false;
  val(LabeledEdit4.Text, dblF, Check);  // N
  if Check <> 0 then begin
    application.MessageBox('k͂̐U̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit5.Text, dblFe, Check); // Hz
  if (Check <> 0) or (dblFe < 0) then begin
    application.MessageBox('k͂̎g̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit10.Text, dblQ, Check); // deg
  if Check <> 0 then begin
    application.MessageBox('k͂̊Jnp̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit6.Text, dblX0, Check); // m([g)
  if Check <> 0 then begin
    application.MessageBox('ψʂ̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit7.Text, dblV0, Check); // m/s
  if Check <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit8.Text, dblTend, Check);   // sec
  if (Check <> 0) or (dblTend <= 0) then begin
    application.MessageBox('ϑ鎞ԂɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit11.Text, dblTstt, Check);  // sec
  if (Check <> 0) or (dblTstt < 0) then begin
    application.MessageBox('ϑJnԂɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit9.Text, dblDt, Check);     // sec
  if (Check <> 0) then begin
    application.MessageBox('ݕɊԈႢ܂B','',0);
    exit;
  end;
  if dblDt <= 0 then begin
    application.MessageBox('ݕ[ ́A[ȉł͂܂B','',0);
    exit;
  end;
  // k͂̊pg
  Omega := 2 * pi * dblFe;
  // k͂̊Jnp
  OmegQ := dblQ / 180 * pi;
  // vZf[^[ - 1
  Number := round((dblTend + dblTstt) / dblDt);
  // ϑJnʒu
  Numbstt := round((dblTstt) / dblDt) + 1;
  dblAK   := -dblK / dblM;
  dblAC   := -dblC / dblM;
  dblB    :=  dblF / dblM;

  result := true;
end;

// x߂܂
// x̓[`ŏ
function TForm1.Func(T: double; X: array of double): double;
begin
  result := dblAK * X[0] + dblAC * X[1] + dblB * cos(Omega * T + OmegQ);
end;

// QNb^[`
procedure TForm1.Runge_Kutta(T, Dt: double;var X, Y: array of double);
var
  Rk1: array[0..1] of double;
  Rk2: array[0..1] of double;
  Rk3: array[0..1] of double;
  Rk4: array[0..1] of double;
  Acc: array[0..1] of double;
  Dt2: double;
  Th2, Th: double;
begin
  Dt2 := Dt / 2;
  Th2 := T + Dt2;
  Th  := T + Dt;

  Rk1[0] := X[1];
  Rk1[1] := Func(T, X);
  Acc[0] := X[0] + Rk1[0] * Dt2;
  Acc[1] := X[1] + Rk1[1] * Dt2;
  Rk2[0] := Acc[1];
  Rk2[1] := Func(Th2, Acc);
  Acc[0] := X[0] + Rk2[0] * Dt2;
  Acc[1] := X[1] + Rk2[1] * Dt2;
  Rk3[0] := Acc[1];
  Rk3[1] := Func(Th2, Acc);
  Acc[0] := X[0] + Rk3[0] * Dt;
  Acc[1] := X[1] + Rk3[1] * Dt;
  Rk4[0] := Acc[1];
  Rk4[1] := Func(Th, Acc);

  Y[0] := (Rk1[0] + 2 * (Rk2[0] + Rk3[0]) + Rk4[0]) / 6;     // ԏdݕtϑx
  Y[1] := (Rk1[1] + 2 * (Rk2[1] + Rk3[1]) + Rk4[1]) / 6;     // ԏdݕtωx
  // ψ + ԏdݕtϑx x 
  X[0] := X[0] + Y[0] * Dt;                                  // ψ
  // x + ԏdݕtωx x 
  X[1] := X[1] + Y[1] * Dt;                                  // x
end;

// ŗLǓvZ
procedure TForm1.calc;
const
  thousand = 1000;
var
  i : integer;
begin
  chart1.LeftAxis.Title.Text := 'ψ(mm)';
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  dblT := 0;                                    // 
  dblY[0] := 0;                                 // ԕϑx
  dblY[1] := 0;                                 // ԕωx
  dblX[0] := dblX0;                             // ψ
  dblX[1] := dblV0;                             // x
  for i := 1 to Numbstt - 1 do begin            // ϑJnԂ܂Ői߂
    Runge_Kutta(dblT, dblDt, dblX, dblY);
    dblT := i * dblDt;
  end;
  Series1.AddXY(dblT, dblX[0] * thousand);      // ψ
  Series2.AddXY(dblT, dblX[1]);                 // x
  for i := Numbstt to Number do begin           // ϑ
    Runge_Kutta(dblT, dblDt, dblX, dblY);
    dblT := i * dblDt;
    Series1.AddXY(dblT, dblX[0] * thousand);    // ψ
    Series2.AddXY(dblT, dblX[1]);               // x
    Series3.AddXY(dblT - dblDt, dblY[1]);       // x
  end;
  Runge_Kutta(dblT, dblDt, dblX, dblY);
  Series3.AddXY(dblT, dblY[1]);                 // x
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not hzcalc then exit;
  if not inputdata then exit;
  calc;
end;

end.
